
local L_TOTAL = "\nTotal"
local L_BLIZZ = "Total & Blizzard AddOns"
local L_TIP = "\n|cffeda55fClick|r to collect garbage"
local L_MB = "MB"
local L_KB = "KB"

local L = GetLocale()
if L == "frFR" then
	L_TOTAL = "\nTotal"
	L_BLIZZ = "Total & AddOns Blizzard"
	L_TIP = "\n|cffeda55fCliquer|r pour récupérer de la mémoire."
	L_MB = "Mo"
	L_KB = "Ko"
end

local Mem = {}
local format = string.format
Mem.obj = _G.LibStub("LibDataBroker-1.1"):NewDataObject("Memory", {type = "data source", value = "0", suffix = L_MB, text = "0 "..L_MB})
_G.LibStub("AceTimer-3.0"):Embed(Mem)

function Mem:Update()
	local current = format("%.1f", _G.collectgarbage("count") / 1024)
	Mem.obj.text = current.." "..L_MB
	Mem.obj.value = current
end

Mem:ScheduleRepeatingTimer("Update", 30)
Mem:ScheduleTimer("Update", 5)

function Mem.obj.OnClick()
	_G.GameTooltip:Hide()
	_G.collectgarbage("collect")
	Mem:Update()
end

local function formatMemory(n)
	if n > 1024 then
		return format("%.2f "..L_MB, n / 1024)
	else
		return format("%.2f "..L_KB, n)
	end
end

local function mySort(x,y)
	return x.mem > y.mem
end

local memTbl = {}
function Mem.obj.OnTooltipShow(tooltip)
	if not tooltip or not tooltip.AddLine or not tooltip.AddDoubleLine then return end

	UpdateAddOnMemoryUsage()
	local grandtotal = collectgarbage("count")
	local total = 0

	local tinsert = _G.table.insert
	local IsAddOnLoaded = _G.IsAddOnLoaded
	local GetAddOnMemoryUsage = _G.GetAddOnMemoryUsage
	local GetAddOnInfo = _G.GetAddOnInfo
	for i = 1, GetNumAddOns() do
		if IsAddOnLoaded(i) then
			local memused = GetAddOnMemoryUsage(i)
			total = total + memused
			tinsert(memTbl, {addon = GetAddOnInfo(i), mem = memused})
		end
	end

	table.sort(memTbl, mySort)
	local txt = "%d. %s"
	local killPoint = tonumber(_G.SB_MEM_KILL) or 0
	for k, v in _G.pairs(memTbl) do
		tooltip:AddDoubleLine(format(txt, k, v.addon), formatMemory(v.mem), 0, 1, 1, 0, 1, 0)
		if k == killPoint then break end
	end
	for i = 1, #memTbl do memTbl[i] = nil end

	tooltip:AddDoubleLine(L_TOTAL, formatMemory(total), 1, 1, 1, 0, 1, 0)
	tooltip:AddDoubleLine(L_BLIZZ, formatMemory(grandtotal), 1, 1, 1, 0, 1, 0)
	tooltip:AddLine(L_TIP, 1, 1, 1)
end

